%% Constraint function used in problems: RosenbrockCubicLine
%L. LAURENT -- 01/05/2018 -- luc.laurent@lecnam.net

% sources available here:
% https://bitbucket.org/luclaurent/optigtest/
% https://github.com/luclaurent/optigtest/

% optiGTest - set of testing functions    A toolbox to easy manipulate functions.
% Copyright (C) 2017  Luc LAURENT <luc.laurent@lecnam.net>
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [g,dg]=funCons1(xx)

% contraint
g=(xx(:,:,1)-1).^3-xx(:,:,2)+1;

%and their derivatives
if nargout>1
    nX=size(xx);
    %
    dg(:,:,1)=3*(xx(:,:,1)-1).^2;
    dg(:,:,2)=-ones(nX(1),nX(2));
end
end
