%% Zitzler-Deb-Thiele N6 2nd objective function
%L. LAURENT -- 09/05/2018 -- luc.laurent@lecnam.net

% sources available here:
% https://bitbucket.org/luclaurent/optigtest/
% https://github.com/luclaurent/optigtest/

% optiGTest - set of testing functions    A toolbox to easy manipulate functions.
% Copyright (C) 2017  Luc LAURENT <luc.laurent@lecnam.net>
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [p,dp]=funObjZitzlerDebThiele62(xx)

%constants
a=9;
b=0.25;

%responses and derivatives
if nargout==2
    [f1,df1]=funObjZitzlerDebThiele61(xx);
else
    f1=funObjZitzlerDebThiele61(xx);
end
%
td=sum(xx(:,:,2:end),3);
g=1+a/a^b*td.^b;
%
rfg=f1./g;
h=1-rfg.^2;
%
p=g.*h;

if nargout==2 
    %
    dg=a/a^b*b*ones(size(xx)).*td.^(b-1);
    dg(:,:,1)=0;
    %
    dh=-(df1.*g-f1.*dg)./g.^2.*2.*rfg;
    %
    dp=dg.*h+g.*dh;
end
end