%% function for loading design space of available multi-objective problems
% L. LAURENT --  04/05/2018 -- luc.laurent@lecnam.net

% sources available here:
% https://bitbucket.org/luclaurent/optigtest/
% https://github.com/luclaurent/optigtest/

% optiGTest - set of testing functions    A toolbox to easy manipulate functions.
% Copyright (C) 2017  Luc LAURENT <luc.laurent@lecnam.net>
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [xMin,xMax]=loadSpaceMulti(funName,dim)
listSpace=struct(...
    'BinhKorn',[0 0;5 3],...
    'ChakongHaimes',20*[-1;1],...
    'FonsecaFleming',4*[-1;1],...
    'TestFun4',[-7;4],...
    'Kursawe',5*[-1;1],...
    'MultiSchaffer1',10*[-1;1],... % change 10 in (10 to 10^5)
    'MultiSchaffer2',[-5;1],...
    'Poloni',pi*[-1;1],...
    'ZitzlerDebThiele1',[0;1],...
    'ZitzlerDebThiele2',[0;1],...
    'ZitzlerDebThiele3',[0;1],...
    'ZitzlerDebThiele4',horzcat([0;1],5*[-ones(1,9);ones(1,9)]),...
    'ZitzlerDebThiele6',[0;1],...
    'OsyczkaKundu',[ 0 0 1 0 1 0;10 10 5 6 5 10],...
    'CTP1',[0 0;1 1],...
    'ConstrEx',[0.1 0;1 5],...
    'Viennet',3*[-1 -1;1 1]);

spaceL=listSpace.(funName);
%
if size(spaceL,2)==1&&~isinf(dim)&&~isnan(dim)
    xMin=ones(1,dim)*spaceL(1);
    xMax=ones(1,dim)*spaceL(2);
else
    xMin=spaceL(1,:);
    xMax=spaceL(2,:);
end
end